
my $binfile = $ARGV[1];

if ( $binfile =~ m/\.bin$/i ) {
  -f $binfile or print "Error: can't find $binfile file needed for flashing." and exit 1;
} else {
  print "Error: Currently only .bin files are accepted.\n";
  print "       Please use the .bin from the original compiled project\n";
  exit 1;
}

my $soffile = "fpga_temp.sof";

system ("aocl binedit $binfile get .acl.sof $soffile");
$? == 0  or die "Error: aocl binedit failed";



my $cof = <<END;
<?xml version="1.0" encoding="US-ASCII" standalone="yes"?>
<cof>
	<eprom_name>CFI_1GB</eprom_name>
	<output_filename>flash.pof</output_filename>
	<n_pages>2</n_pages>
	<width>1</width>
	<mode>12</mode>
	<sof_data>
		<start_address>02140000</start_address>
		<user_name>Page_2</user_name>
		<page_flags>4</page_flags>
		<bit0>
			<sof_filename>$soffile</sof_filename>
		</bit0>
	</sof_data>
	<sof_data>
		<start_address>00040000</start_address>
		<user_name>Page_1</user_name>
		<page_flags>2</page_flags>
		<bit0>
			<sof_filename>$soffile</sof_filename>
		</bit0>
	</sof_data>
	<version>5</version>
	<create_cvp_file>0</create_cvp_file>
	<options>
		<map_file>1</map_file>
		<option_start_address>0</option_start_address>
		<dynamic_compression>0</dynamic_compression>
	</options>
</cof>
END

my $cdf = <<CDFEND;
JedecChain;
	FileRevision(JESD32A);
	DefaultMfr(6E);

	P ActionCode(Ign)
		Device PartName(5SGXEA7H2) MfrSpec(OpMask(0));
	P ActionCode(Ign)
		Device PartName(EPM2210) MfrSpec(OpMask(0) SEC_Device(CFI_1GB) Child_OpMask(4 1 1 1 1) PFLPath("flash.pof"));

ChainEnd;

AlteraBegin;
	ChainType(JTAG);
AlteraEnd;
CDFEND

open COFFILE, ">flash.cof";
print COFFILE $cof;
close COFFILE;

open CDFFILE, ">flash.cdf";
print CDFFILE $cdf;
close CDFFILE;

system ("quartus_cpf --convert flash.cof");
$? == 0  or die "Error: quartus_cpf failed";

system ("quartus_pgm -c 1 flash.cdf");
$? == 0  or die "Error: quartus_cpf failed";
